      real(8) function cross(x)
c----------------------------------------------------------------------c
c The unpolarized cross section
c
c Input:  x(20) - random numbers supplied by Vegas.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 20 June, 2001, modiffied 27 March, 2002
c----------------------------------------------------------------------c

      use drivec
      use kincuts
      use inprms
      use mathprms 
      use parproc
      use distribs

      implicit none

      real(8) :: x(20)
      real(8), dimension(0:3) :: p1,p2,p3,p45,p6,p78,p4,p5,p7,p8,
     &                           p0,p30,p40,p50,p60
      real(8), dimension(0:4) :: ps1,ps2,ps3,ps45,ps6,ps78,
     &                           ps4,ps5,ps7,ps8,
     &                           ps0,ps30,ps40,ps50,ps60
      real(8), dimension(1:3) :: pv345

      real(8) :: dlips,flux,mat2,dlinv,rand

      integer :: i,j,ikin0

      real(8) :: mat2m,crossm,stbtn,stbtng,sum,s345,s678,srr,sbnmbw,
     &           sbwbtn,snmtnz,snmduz,snmdug,sbmbmz,sbubuz

      integer :: ifirst=1

      save

c      if (imad == 1) then
c       if (ifirst == 1) then
c        call initialize
c        ifirst=0
c       end if
c      end if

      if (idrive == 1) then

       if (ikin == 1) then
        call kineett6f(1,1,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                 p5,ps5,m5,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 2) then
        call kineett6f(1,0,1,1,mt,gamt,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                 p5,ps5,m5,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 3) then
        call kineett6f(0,1,1,1,zero,zero,mt,gamt,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                 p5,ps5,m5,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 4) then
       call kineett6f(0,0,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                 p5,ps5,m5,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 5) then
        call kinee6f(1,0,1,1,
     &               mw,gamw,zero,zero,mz,gamz,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 6) then
        call kinee6f(2,2,1,1,
     &               zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 7) then
        call kinee6f(2,1,1,1,
     &               zero,zero,mz,gamz,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 8) then
        call kinee6f(1,2,1,1,
     &               mz,gamz,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 9) then
        call kinee6f(1,1,1,1,
     &               mz,gamz,mz,gamz,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 10) then
        call kinee6f(1,1,0,1,
     &               mw,gamw,mw,gamw,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 11) then
        call kinee6f(1,0,2,1,
     &               mw,gamw,zero,zero,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 12) then
        call kinee6f(1,0,1,1,
     &               mw,gamw,zero,zero,mz,gamz,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 13) then
        call kinee6f(1,1,2,1,
     &               mw,gamw,mw,gamw,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 14) then
        call kinee6f(1,1,1,1,
     &               mw,gamw,mw,gamw,mz,gamz,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 15) then
        call kinee6f(1,1,1,1,
     &               mw,gamw,mw,gamw,mh,gamhig,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 16) then
        call kinee6f(2,0,1,1,
     &               zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 17) then
        call kinee6f(1,0,1,1,
     &               mz,gamz,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 18) then
        call kinee6f(2,2,1,1,
     &               zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 19) then
        call kinee6f(2,1,1,1,
     &               zero,zero,mz,gamz,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 20) then
        call kinee6f(1,2,1,1,
     &               mz,gamz,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 21) then
        call kinee6f(1,1,1,1,
     &               mz,gamz,mz,gamz,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 22) then
        call kinee6f(1,1,2,1,
     &               mw,gamw,mw,gamw,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p8,ps8,m8,
     &               p3,ps3,m3,p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 23) then
        call kinee6f(1,1,1,1,
     &               mw,gamw,mw,gamw,mz,gamz,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p8,ps8,m8,
     &               p3,ps3,m3,p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 24) then
        call kinee6f(1,1,1,1,
     &               mw,gamw,mw,gamw,mh,gamhig,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p8,ps8,m8,
     &               p3,ps3,m3,p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 25) then
        call kinee6f(1,1,1,1,
     &               mz,gamz,mh,gamhig,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 26) then
        call kinee6f(1,1,1,1,
     &               mh,gamhig,mz,gamz,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 27) then
        call kinee6f(0,2,1,1,
     &               zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 28) then
        call kinee6f(0,1,1,1,
     &               zero,zero,mz,gamz,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 29) then
        call kinee6f(0,1,1,1,
     &               zero,zero,mh,gamhig,mw,gamw,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 30) then
        call kineett6f(1,1,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p7,ps7,m7,
     &                 p8,ps8,m8,p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 31) then
        call kineett6f(1,0,1,1,mt,gamt,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p7,ps7,m7,
     &                 p8,ps8,m8,p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 32) then
        call kineett6f(0,1,1,1,zero,zero,mt,gamt,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p7,ps7,m7,
     &                 p8,ps8,m8,p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 33) then
       call kineett6f(0,0,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
     &                 p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p7,ps7,m7,
     &                 p8,ps8,m8,p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
c       else if (ikin == 34) then
c       call kinee32(0,0,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
c     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,
c     &              p6,ps6,m6,p7,ps7,mw,dl(ikin),flux)
c       else if (ikin == 35) then
c       call kinee32(0,0,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,x,
c     &              p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
c     &              p3,ps3,m3,p4,ps4,mw,dl(ikin),flux)
c       else if (ikin == 36) then
c       call kinee32(0,0,0,0,zero,zero,zero,zero,zero,zero,zero,zero,
c     &              ecm,x,
c     &              p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
c     &              p7,ps7,m7,p8,ps8,m8,p3,ps3,mz,dl(ikin),flux)
       else if (ikin == 34) then
        call kinee6f(2,2,0,1,
     &               zero,zero,zero,zero,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 35) then
        call kinee6f(2,1,0,1,
     &               zero,zero,mz,gamz,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 36) then
        call kinee6f(1,2,0,1,
     &               mz,gamz,zero,zero,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 37) then
        call kinee6f(1,1,0,1,
     &               mz,gamz,mz,gamz,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p4,ps4,m4,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 38) then
        call kinee6f(1,1,2,0,
     &               mw,gamw,mw,gamw,zero,zero,zero,zero,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p8,ps8,m8,
     &               p3,ps3,m3,p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 39) then
        call kinee6f(1,1,1,0,
     &               mw,gamw,mw,gamw,mz,gamz,zero,zero,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p8,ps8,m8,
     &               p3,ps3,m3,p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 40) then
       call kineett6f(0,0,2,1,zero,zero,zero,zero,zero,zero,mw,gamw,ecm,
     &              x,p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                p4,ps4,m4,p7,ps7,m7,p8,ps8,m8,dl(ikin),flux)
       else if (ikin == 41) then
       call kineett6f(0,0,1,1,zero,zero,zero,zero,mz,gamz,mw,gamw,ecm,
     &              x,p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                p4,ps4,m4,p7,ps7,m7,p8,ps8,m8,dl(ikin),flux)
       else if (ikin == 42) then
        call kinee6f(2,2,0,1,
     &               zero,zero,zero,zero,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p7,ps7,m7,p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 43) then
        call kinee6f(2,1,0,1,
     &               zero,zero,mz,gamz,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p7,ps7,m7,p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 44) then
        call kinee6f(1,2,0,1,
     &               mz,gamz,zero,zero,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p7,ps7,m7,p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
          else if (ikin == 45) then
        call kinee6f(1,1,0,1,
     &               mz,gamz,mz,gamz,zero,zero,mw,gamw,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &               p7,ps7,m7,p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,
     &                                                    dl(ikin),flux)
       else if (ikin == 46) then
        call kinee6f(1,1,2,0,
     &               mw,gamw,mw,gamw,zero,zero,zero,zero,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 47) then
        call kinee6f(1,1,1,0,
     &               mw,gamw,mw,gamw,mz,gamz,zero,zero,ecm,x,
     &               p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
     &               p3,ps3,m3,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dl(ikin),flux)
       else if (ikin == 48) then
       call kineett6f(0,0,2,1,zero,zero,zero,zero,zero,zero,mw,gamw,ecm,
     &              x,p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p3,ps3,m3,p6,ps6,m6,
     &                p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)
       else if (ikin == 49) then
       call kineett6f(0,0,1,1,zero,zero,zero,zero,mz,gamz,mw,gamw,ecm,
     &              x,p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p3,ps3,m3,p6,ps6,m6,
     &                p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)

       else if (ikin == 50) then
        call kinee1212(0,1,1,1,zero,zero,mw,gamw,mt,gamt,mw,gamw,ecm,x,
     &            p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,
     &            p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,dl(ikin),flux)
       else if (ikin == 51) then
        call kinee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &          x,p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p4,ps4,m4,p5,ps5,m5,
     &            p8,ps8,m8,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 52) then
        call kinee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &      ecm,x,p1,ps1,m1,p2,ps2,m2,p7,ps7,m7,p4,ps4,m4,p5,ps5,m5,
     &            p8,ps8,m8,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 53) then
        call kinee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &          x,p1,ps1,m1,p2,ps2,m2,p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,
     &            p7,ps7,m7,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 54) then
        call kinee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &      ecm,x,p1,ps1,m1,p2,ps2,m2,p8,ps8,m8,p4,ps4,m4,p5,ps5,m5,
     &            p7,ps7,m7,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)

       else if (ikin == 55) then
        call kinee1212(0,1,1,1,zero,zero,mw,gamw,mt,gamt,mw,gamw,ecm,x,
     &            p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &            p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)
       else if (ikin == 56) then
        call kinee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &          x,p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p7,ps7,m7,p8,ps8,m8,
     &            p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 57) then
        call kinee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &      ecm,x,p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p7,ps7,m7,p8,ps8,m8,
     &            p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 58) then
        call kinee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &          x,p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &            p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 59) then
        call kinee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &      ecm,x,p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p7,ps7,m7,p8,ps8,m8,
     &            p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else
       write(*,*)'ikin =',ikin,' IS NOT ALLOWED'
      end if  ! ikin

      ikin0=ikin

      if (dl(ikin) > 0.d0) then

       if (icuts == 1) then
c Impose cuts:
        call impcuts(p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,
     &               p7,ps7,p8,ps8,cross)
        if (cross == 0.d0) then
         cstt0=zero
         return
        end if
       end if ! icut

      dlinv=0.d0


      if (ikin0 /= 1 .and. aw(1) > 0.d0) then
       call psneett6f(1,1,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p3,m3,p4,m4,
     &                p5,m5,p6,m6,p7,m7,p8,m8,dl(1))
      end if

      if (ikin0 /= 2 .and. aw(2) > 0.d0) then
       call psneett6f(1,0,1,1,mt,gamt,zero,zero,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p3,m3,p4,m4,
     &                p5,m5,p6,m6,p7,m7,p8,m8,dl(2))
      end if

      if (ikin0 /= 3 .and. aw(3) > 0.d0) then
       call psneett6f(0,1,1,1,zero,zero,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p3,m3,p4,m4,
     &                p5,m5,p6,m6,p7,m7,p8,m8,dl(3))
      end if

      if (ikin0 /= 4 .and. aw(4) > 0.d0) then
       call psneett6f(0,0,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p3,m3,p4,m4,
     &                p5,m5,p6,m6,p7,m7,p8,m8,dl(4))
      end if

      if (ikin0 /= 5 .and. aw(5) > 0.d0) then
       call psnee6f(1,0,1,1,mw,gamw,zero,zero,mz,gamz,mw,gamw,ecm,
     &              p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                        dl(5))
      end if

      if (ikin0 /= 6 .and. aw(6) > 0.d0) then
       call psnee6f(2,2,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                        dl(6))
      end if

      if (ikin0 /= 7 .and. aw(7) > 0.d0) then
       call psnee6f(2,1,1,1,zero,zero,mz,gamz,mw,gamw,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                        dl(7))
      end if

      if (ikin0 /= 8 .and. aw(8) > 0.d0) then
        call psnee6f(1,2,1,1,mz,gamz,zero,zero,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(8))
      end if

      if (ikin0 /= 9 .and. aw(9) > 0.d0) then
        call psnee6f(1,1,1,1,mz,gamz,mz,gamz,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(9))
      end if

      if (ikin0 /= 10 .and. aw(10) > 0.d0) then
        call psnee6f(1,1,0,1,mw,gamw,mw,gamw,zero,zero,mw,gamw,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(10))
      end if

      if (ikin0 /= 11 .and. aw(11) > 0.d0) then
        call psnee6f(1,0,2,1,mw,gamw,zero,zero,zero,zero,mw,gamw,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(11))
      end if

      if (ikin0 /= 12 .and. aw(12) > 0.d0) then
        call psnee6f(1,0,1,1,mw,gamw,zero,zero,mz,gamz,mw,gamw,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(12))
      end if

      if (ikin0 /= 13 .and. aw(13) > 0.d0) then
        call psnee6f(1,1,2,1,mw,gamw,mw,gamw,zero,zero,mw,gamw,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(13))
      end if

      if (ikin0 /= 14 .and. aw(14) > 0.d0) then
        call psnee6f(1,1,1,1,mw,gamw,mw,gamw,mz,gamz,mw,gamw,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(14))
      end if

      if (ikin0 /= 15 .and. aw(15) > 0.d0) then
        call psnee6f(1,1,1,1,mw,gamw,mw,gamw,mh,gamhig,mw,gamw,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(15))
      end if

      if (ikin0 /= 16 .and. aw(16) > 0.d0) then
        call psnee6f(2,0,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(16))
      end if

      if (ikin0 /= 17 .and. aw(17) > 0.d0) then
        call psnee6f(1,0,1,1,mz,gamz,zero,zero,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(17))
      end if

      if (ikin0 /= 18 .and. aw(18) > 0.d0) then
        call psnee6f(2,2,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(18))
      end if

      if (ikin0 /= 19 .and. aw(19) > 0.d0) then
        call psnee6f(2,1,1,1,zero,zero,mz,gamz,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(19))
      end if

      if (ikin0 /= 20 .and. aw(20) > 0.d0) then
        call psnee6f(1,2,1,1,mz,gamz,zero,zero,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(20))
      end if

      if (ikin0 /= 21 .and. aw(21) > 0.d0) then
        call psnee6f(1,1,1,1,mz,gamz,mz,gamz,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(21))
      end if

      if (ikin0 /= 22 .and. aw(22) > 0.d0) then
        call psnee6f(1,1,2,1,mw,gamw,mw,gamw,zero,zero,mw,gamw,ecm,
     &               p1,m1,p2,m2,p7,m7,p8,m8,p3,m3,p6,m6,p4,m4,p5,m5,
     &                                                    dl(22))
      end if

      if (ikin0 /= 23 .and. aw(23) > 0.d0) then
        call psnee6f(1,1,1,1,mw,gamw,mw,gamw,mz,gamz,mw,gamw,ecm,
     &               p1,m1,p2,m2,p7,m7,p8,m8,p3,m3,p6,m6,p4,m4,p5,m5,
     &                                                    dl(23))
      end if

      if (ikin0 /= 24 .and. aw(24) > 0.d0) then
        call psnee6f(1,1,1,1,mw,gamw,mw,gamw,mh,gamhig,mw,gamw,ecm,
     &               p1,m1,p2,m2,p7,m7,p8,m8,p3,m3,p6,m6,p4,m4,p5,m5,
     &                                                    dl(24))
      end if

      if (ikin0 /= 25 .and. aw(25) > 0.d0) then
        call psnee6f(1,1,1,1,mz,gamz,mh,gamhig,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(25))
      end if

      if (ikin0 /= 26 .and. aw(26) > 0.d0) then
        call psnee6f(1,1,1,1,mh,gamhig,mz,gamz,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(26))
      end if

      if (ikin0 /= 27 .and. aw(27) > 0.d0) then
        call psnee6f(0,2,1,1,zero,zero,zero,zero,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(27))
      end if

      if (ikin0 /= 28 .and. aw(28) > 0.d0) then
        call psnee6f(0,1,1,1,zero,zero,mz,gamz,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(28))
      end if

      if (ikin0 /= 29 .and. aw(29) > 0.d0) then
        call psnee6f(0,1,1,1,zero,zero,mh,gamhig,mw,gamw,mw,gamw,ecm,
     &               p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                    dl(29))
      end if

      if (ikin0 /= 30 .and. aw(30) > 0.d0) then
       call psneett6f(1,1,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p6,m6,p7,m7,p8,m8,
     &                p3,m3,p4,m4,p5,m5,dl(30))
      end if

      if (ikin0 /= 31 .and. aw(31) > 0.d0) then
       call psneett6f(1,0,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p6,m6,p7,m7,p8,m8,
     &                p3,m3,p4,m4,p5,m5,dl(31))
      end if

      if (ikin0 /= 32 .and. aw(32) > 0.d0) then
       call psneett6f(0,1,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p6,m6,p7,m7,p8,m8,
     &                p3,m3,p4,m4,p5,m5,dl(32))
      end if

      if (ikin0 /= 33 .and. aw(33) > 0.d0) then
       call psneett6f(0,0,1,1,mt,gamt,mt,gamt,mw,gamw,mw,gamw,ecm,
     &                p1,m1,p2,m2,p6,m6,p7,m7,p8,m8,
     &                p3,m3,p4,m4,p5,m5,dl(33))
      end if

      if (ikin0 /= 34 .and. aw(34) > 0.d0) then
       call psnee6f(2,2,0,1,zero,zero,zero,zero,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                        dl(34))
      end if

      if (ikin0 /= 35 .and. aw(35) > 0.d0) then
       call psnee6f(2,1,0,1,zero,zero,mz,gamz,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                        dl(35))
      end if

      if (ikin0 /= 36 .and. aw(36) > 0.d0) then
       call psnee6f(1,2,0,1,mz,gamz,zero,zero,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                        dl(36))
      end if

      if (ikin0 /= 37 .and. aw(37) > 0.d0) then
       call psnee6f(1,1,0,1,mz,gamz,mz,gamz,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,p7,m7,p8,m8,
     &                                                        dl(37))
      end if

      if (ikin0 /= 38 .and. aw(38) > 0.d0) then
        call psnee6f(1,1,2,0,mw,gamw,mw,gamw,zero,zero,zero,zero,ecm,
     &               p1,m1,p2,m2,p7,m7,p8,m8,p3,m3,p6,m6,p4,m4,p5,m5,
     &                                                    dl(38))
      end if

      if (ikin0 /= 39 .and. aw(39) > 0.d0) then
        call psnee6f(1,1,1,0,mw,gamw,mw,gamw,mz,gamz,zero,zero,ecm,
     &               p1,m1,p2,m2,p7,m7,p8,m8,p3,m3,p6,m6,p4,m4,p5,m5,
     &                                                    dl(39))
      end if

      if (ikin0 /= 40 .and. aw(40) > 0.d0) then
       call psneett6f(0,0,2,1,zero,zero,zero,zero,zero,zero,mw,gamw,ecm,
     &                p1,m1,p2,m2,p5,m5,p3,m3,p6,m6,p4,m4,
     &                p7,m7,p8,m8,dl(40))
      end if

      if (ikin0 /= 41 .and. aw(41) > 0.d0) then
       call psneett6f(0,0,1,1,zero,zero,zero,zero,mz,gamz,mw,gamw,ecm,
     &                p1,m1,p2,m2,p5,m5,p3,m3,p6,m6,p4,m4,
     &                p7,m7,p8,m8,dl(41))
      end if

      if (ikin0 /= 42 .and. aw(42) > 0.d0) then
       call psnee6f(2,2,0,1,zero,zero,zero,zero,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p7,m7,p8,m8,p4,m4,p5,m5,
     &                                                        dl(42))
      end if

      if (ikin0 /= 43 .and. aw(43) > 0.d0) then
       call psnee6f(2,1,0,1,zero,zero,mz,gamz,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p7,m7,p8,m8,p4,m4,p5,m5,
     &                                                        dl(43))
      end if

      if (ikin0 /= 44 .and. aw(44) > 0.d0) then
       call psnee6f(1,2,0,1,mz,gamz,zero,zero,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p7,m7,p8,m8,p4,m4,p5,m5,
     &                                                        dl(44))
      end if

      if (ikin0 /= 45 .and. aw(45) > 0.d0) then
       call psnee6f(1,1,0,1,mz,gamz,mz,gamz,zero,zero,mw,gamw,ecm,
     &              p1,m1,p2,m2,p3,m3,p6,m6,p7,m7,p8,m8,p4,m4,p5,m5,
     &                                                        dl(45))
      end if

      if (ikin0 /= 46 .and. aw(46) > 0.d0) then
        call psnee6f(1,1,2,0,mw,gamw,mw,gamw,zero,zero,zero,zero,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(46))
      end if

      if (ikin0 /= 47 .and. aw(47) > 0.d0) then
        call psnee6f(1,1,1,0,mw,gamw,mw,gamw,mz,gamz,zero,zero,ecm,
     &               p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,p7,m7,p8,m8,
     &                                                    dl(47))
      end if

      if (ikin0 /= 48 .and. aw(48) > 0.d0) then
       call psneett6f(0,0,2,1,zero,zero,zero,zero,zero,zero,mw,gamw,ecm,
     &                p1,m1,p2,m2,p7,m7,p3,m3,p6,m6,p8,m8,p4,m4,p5,m5,
     &                dl(48))
      end if

      if (ikin0 /= 49 .and. aw(49) > 0.d0) then
       call psneett6f(0,0,1,1,zero,zero,zero,zero,mz,gamz,mw,gamw,ecm,
     &                p1,m1,p2,m2,p7,m7,p3,m3,p6,m6,p8,m8,p4,m4,p5,m5,
     &                dl(49))
      end if

      if (ikin0 /= 50 .and. aw(50) > 0.d0) then
        call psnee1212(0,1,1,1,zero,zero,mw,gamw,mt,gamt,mw,gamw,ecm,
     &            p1,m1,p2,m2,p3,m3,p4,m4,p5,m5,
     &            p6,m6,p7,m7,p8,m8,dl(50))
      end if

      if (ikin0 /= 51 .and. aw(51) > 0.d0) then
        call psnee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &            p1,m1,p2,m2,p7,m7,p4,m4,p5,m5,
     &            p8,m8,p3,m3,p6,m6,dl(51))
      end if

      if (ikin0 /= 52 .and. aw(52) > 0.d0) then
        call psnee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &        ecm,p1,m1,p2,m2,p7,m7,p4,m4,p5,m5,
     &            p8,m8,p3,m3,p6,m6,dl(52))
      end if

      if (ikin0 /= 53 .and. aw(53) > 0.d0) then
        call psnee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &            p1,m1,p2,m2,p8,m8,p4,m4,p5,m5,
     &            p7,m7,p3,m3,p6,m6,dl(53))
      end if

      if (ikin0 /= 54 .and. aw(54) > 0.d0) then
        call psnee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &      ecm,  p1,m1,p2,m2,p8,m8,p4,m4,p5,m5,
     &            p7,m7,p3,m3,p6,m6,dl(54))
      end if

      if (ikin0 /= 55 .and. aw(55) > 0.d0) then
        call psnee1212(0,1,1,1,zero,zero,mw,gamw,mt,gamt,mw,gamw,ecm,
     &            p1,m1,p2,m2,p6,m6,p7,m7,p8,m8,
     &            p3,m3,p4,m4,p5,m5,dl(55))
      end if

      if (ikin0 /= 56 .and. aw(56) > 0.d0) then
        call psnee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &            p1,m1,p2,m2,p4,m4,p7,m7,p8,m8,
     &            p5,m5,p3,m3,p6,m6,dl(56))
      end if

      if (ikin0 /= 57 .and. aw(57) > 0.d0) then
        call psnee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &        ecm,p1,m1,p2,m2,p4,m4,p7,m7,p8,m8,
     &            p5,m5,p3,m3,p6,m6,dl(57))
      end if

      if (ikin0 /= 58 .and. aw(58) > 0.d0) then
        call psnee1212(0,1,0,1,zero,zero,mw,gamw,zero,zero,mz,gamz,ecm,
     &            p1,m1,p2,m2,p5,m5,p7,m7,p8,m8,
     &            p4,m4,p3,m3,p6,m6,dl(58))
      end if

      if (ikin0 /= 59 .and. aw(59) > 0.d0) then
        call psnee1212(0,1,0,2,zero,zero,mw,gamw,zero,zero,zero,zero,
     &        ecm,p1,m1,p2,m2,p5,m5,p7,m7,p8,m8,
     &            p4,m4,p3,m3,p6,m6,dl(59))
      end if


      do i=1,nkin
       if (dl(i) /= 0.d0 .and. aw(i) > zero) then
        dlinv=dlinv+aw(i)/abs(dl(i))
       end if
      end do

      if (dlinv == 0.d0) then
       cross=0.d0
       return
      else

      dlips=1.d0/dlinv

      if (imad == 1) then

c       call kinee32(0,0,0,0,zero,zero,zero,zero,zero,zero,zero,zero,
c     &              ecm,x,
c     &              p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,p5,ps5,m5,
c     &              p7,ps7,m7,p8,ps8,m8,p3,ps3,mz,dl(ikin),flux)
c       call kinee32(0,0,0,0,zero,zero,zero,zero,zero,zero,zero,zero,
c     &              ecm,x,
c     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p5,ps5,m5,
c     &              p6,ps6,m6,p7,ps7,m7,p8,ps8,mz,dl(ikin),flux)
c       call kinee32(0,0,0,0,zero,zero,zero,zero,zero,zero,zero,zero,
c     &              ecm,x,
c     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
c     &              p6,ps6,m6,p7,ps7,mz,p8,ps8,m8,dl(ikin),flux)

c       p6=zero
c       ps6=zero
c       p5=zero
c       ps5=zero

        call kineett6f(0,0,0,0,0.d0,0.d0,0.d0,0.d0,0.d0,0.d0,0.d0,0.d0,
     &                 ecm,x,p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                 p5,ps5,m5,p6,ps6,m6,p7,ps7,m7,p8,ps8,m8,
     &                                                    dlips,flux)

       call eett6f(iwp,iwm,p1,p2,p3,p4,p5,p6,p7,p8,
     &                  ps1,ps2,ps3,ps4,ps5,ps6,ps7,ps8,mat2)


c       call initialize
c       mat2m=stbtn(p1,p2,p3,p4,p5,p7,p8)
c       write(*,*) mat2/3.d0,mat2m,mat2/3.d0-mat2m
c       mat2m=sbmbmz(p1,p2,p3,p5,p6,p7,p8)
c       mat2m=sbubuz(p1,p2,p3,p4,p6,p8,p7)
c       write(*,*) mat2,3*mat2m,mat2-3*mat2m
c       write(*,*) 'cross', convc/flux*mat2*dlips


      else if (imad == 2) then
       mat2=1.d0
      else

        call eett6f(iwp,iwm,p1,p2,p3,p4,p5,p6,p7,p8,
     &                  ps1,ps2,ps3,ps4,ps5,ps6,ps7,ps8,mat2)

      end if ! imad=2

      cross=convc/flux*mat2*dlips

      icall=icall+1

c Find the maximum of cross

      if (cross > crmax) then
       if (iscan == 0) then
        write(*,3010) crmax,cross
 3010 format('# The maximum weight updated from',e15.8,' to ',e15.8)
       end if
       crmax=cross
      end if

      if (iscan == 0) then

      call random_number(rand)

      if (cross > rand*crmax) then
       ieff=ieff+1
       if (imc == 1) then
        write(*,1000) ieff
        write(*,1030) p3
        write(*,1040) p4
        write(*,1050) p5
        write(*,1060) p6
        write(*,1070) p7
        write(*,1080) p8
       end if
      end if

      end if

 1000 format('Event No.',i10,':')
 1030 format('p3:',4e16.8)
 1040 format('p4:',4e16.8)
 1050 format('p5:',4e16.8)
 1060 format('p6:',4e16.8)
 1070 format('p7:',4e16.8)
 1080 format('p8:',4e16.8)

c      if (imad == 1) then
c          mat2m=stbtn(p1,p2,p3,p4,p6,p7,p8)
c          mat2m=sbnmbw(p1,p2,p3,p4,p5,p6,p7)
c          mat2m=sbwbtn(p1,p2,p3,p4,p6,p7,p8)
c          mat2m=snmtnz(p1,p2,p4,p5,p7,p8,p3)
c          mat2m=snmduz(p1,p2,p4,p5,p7,p8,p3)
c          crossm=convc/flux*mat2m*dlips
c          write(*,*) mat2/3.d0,mat2m,mat2/3.d0-mat2m
c      end if ! imad



       end if  !  dlinv

       else  !  dl(ikin) 

        cross=0.d0
        return

       end if  !  dl(ikin) 

      else if (idrive == 2) then

      if (ikin == 1) then
       call kineetbff(1,1,ecm,mw,gamw,mt,gamt,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p3,ps3,m3,
     &                p6,ps6,m6,p78,ps78,mw,dl(ikin),flux)
      else if (ikin == 2) then
       call kineetbff(1,1,ecm,mw,gamw,mt,gamt,x,
     &                p1,ps1,m1,p2,ps2,m2,p78,ps78,mw,p6,ps6,m6,
     &                p45,ps45,mw,p3,ps3,m3,dl(ikin),flux)
      else if (ikin == 3) then
       call kineetbff(1,1,ecm,mw,gamw,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p78,ps78,mw,p45,ps45,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 4) then
       call kineetbff(1,1,ecm,mw,gamw,mh,gamhig,x,
     &                p1,ps1,m1,p2,ps2,m2,p78,ps78,mw,p45,ps45,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 5) then
       call kineetbff(1,2,ecm,mw,gamw,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p78,ps78,mw,p45,ps45,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 6) then
       call kineetbff(1,1,ecm,mw,gamw,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p78,ps78,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 7) then
       call kineetbff(1,1,ecm,mw,gamw,mh,gamhig,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p78,ps78,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 8) then
       call kineetbff(1,2,ecm,mw,gamw,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p78,ps78,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 9) then
       call kineetbff(0,1,ecm,zero,zero,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &                p78,ps78,mw,p45,ps45,mw,dl(ikin),flux)
      else if (ikin == 10) then
       call kineetbff(0,1,ecm,zero,zero,mh,gamhig,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &                p78,ps78,mw,p45,ps45,mw,dl(ikin),flux)
      else if (ikin == 11) then
       call kineetbff(0,2,ecm,zero,zero,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &                p78,ps78,mw,p45,ps45,mw,dl(ikin),flux)
      else if (ikin == 12) then
       call kineetbff(0,1,ecm,zero,zero,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p3,ps3,m3,
     &                p78,ps78,mw,p45,ps45,mw,dl(ikin),flux)
      else if (ikin == 13) then
       call kineetbff(0,1,ecm,zero,zero,mh,gamhig,x,
     &                p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p3,ps3,m3,
     &                p78,ps78,mw,p45,ps45,mw,dl(ikin),flux)
      else if (ikin == 14) then
       call kineetbff(0,2,ecm,zero,zero,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,p3,ps3,m3,
     &                p78,ps78,mw,p45,ps45,mw,dl(ikin),flux)
      else if (ikin == 15) then
       call kineeffff(0,0,1,1,ecm,mt,gamt,mt,gamt,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &                p45,ps45,mw,p6,ps6,m6,p78,ps78,mw,dl(ikin),flux)
      else if (ikin == 16) then
       call kineeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p78,ps78,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 17) then
       call kineeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &                p45,ps45,mw,p78,ps78,mw,dl(ikin),flux)
      else if (ikin == 18) then
       call kineeffff(0,0,2,2,ecm,zero,zero,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p78,ps78,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 19) then
       call kineeffff(0,0,2,2,ecm,zero,zero,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &                p45,ps45,mw,p78,ps78,mw,dl(ikin),flux)
      else if (ikin == 20) then
       call kineeffff(0,0,1,2,ecm,mz,gamz,zero,zero,x,
     &                p1,ps1,m1,p2,ps2,m2,p45,ps45,mw,p78,ps78,mw,
     &                p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
      else if (ikin == 21) then
       call kineeffff(0,0,2,1,ecm,zero,zero,mz,gamz,x,
     &                p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p6,ps6,m6,
     &                p45,ps45,mw,p78,ps78,mw,dl(ikin),flux)
      else
       write(*,*)'ikin =',ikin,' IS NOT ALLOWED'
      end if  ! ikin

      ikin0=ikin

      if (dl(ikin) > 0.d0) then

c       if (icuts == 1) then
c The canonical cuts:
c        call cancuts(p1,ps1,p2,ps2,p3,ps3,p45,ps45,p6,ps6,
c     &               p78,ps78,cross)
c       end if ! icut

c       if (cross == 0.d0) then
c        return
c       end if

      dlinv=0.d0


      if (ikin0 /= 1 .and. awa(1) > 0.d0) then
       call psneetbff(1,1,ecm,mw,gamw,mt,gamt,
     &                p1,m1,p2,m2,p45,mw,p3,m3,
     &                p6,m6,p78,mw,dl(1))
      end if
      if (ikin0 /= 2 .and. awa(2) > 0.d0) then
       call psneetbff(1,1,ecm,mw,gamw,mt,gamt,
     &                p1,m1,p2,m2,p78,mw,p6,m6,
     &                p45,mw,p3,m3,dl(2))
      end if
      if (ikin0 /= 3 .and. awa(3) > 0.d0) then
       call psneetbff(1,1,ecm,mw,gamw,mz,gamz,
     &                p1,m1,p2,m2,p78,mw,p45,mw,
     &                p3,m3,p6,m6,dl(3))
      end if
      if (ikin0 /= 4 .and. awa(4) > 0.d0) then
       call psneetbff(1,1,ecm,mw,gamw,mh,gamhig,
     &                p1,m1,p2,m2,p78,mw,p45,mw,
     &                p3,m3,p6,m6,dl(4))
      end if
      if (ikin0 /= 5 .and. awa(5) > 0.d0) then
       call psneetbff(1,2,ecm,mw,gamw,zero,zero,
     &                p1,m1,p2,m2,p78,mw,p45,mw,
     &                p3,m3,p6,m6,dl(5))
      end if
      if (ikin0 /= 6 .and. awa(6) > 0.d0) then
       call psneetbff(1,1,ecm,mw,gamw,mz,gamz,
     &                p1,m1,p2,m2,p45,mw,p78,mw,
     &                p3,m3,p6,m6,dl(6))
      end if
      if (ikin0 /= 7 .and. awa(7) > 0.d0) then
       call psneetbff(1,1,ecm,mw,gamw,mh,gamhig,
     &                p1,m1,p2,m2,p45,mw,p78,mw,
     &                p3,m3,p6,m6,dl(7))
      end if
      if (ikin0 /= 8 .and. awa(8) > 0.d0) then
       call psneetbff(1,2,ecm,mw,gamw,zero,zero,
     &                p1,m1,p2,m2,p45,mw,p78,mw,
     &                p3,m3,p6,m6,dl(8))
      end if
      if (ikin0 /= 9 .and. awa(9) > 0.d0) then
       call psneetbff(0,1,ecm,zero,zero,mz,gamz,
     &                p1,m1,p2,m2,p3,m3,p6,m6,
     &                p78,mw,p45,mw,dl(9))
      end if
      if (ikin0 /= 10 .and. awa(10) > 0.d0) then
       call psneetbff(0,1,ecm,zero,zero,mh,gamhig,
     &                p1,m1,p2,m2,p3,m3,p6,m6,
     &                p78,mw,p45,mw,dl(10))
      end if
      if (ikin0 /= 11 .and. awa(11) > 0.d0) then
       call psneetbff(0,2,ecm,zero,zero,zero,zero,
     &                p1,m1,p2,m2,p3,m3,p6,m6,
     &                p78,mw,p45,mw,dl(11))
      end if
      if (ikin0 /= 12 .and. awa(12) > 0.d0) then
       call psneetbff(0,1,ecm,zero,zero,mz,gamz,
     &                p1,m1,p2,m2,p6,m6,p3,m3,
     &                p78,mw,p45,mw,dl(12))
      end if
      if (ikin0 /= 13 .and. awa(13) > 0.d0) then
       call psneetbff(0,1,ecm,zero,zero,mh,gamhig,
     &                p1,m1,p2,m2,p6,m6,p3,m3,
     &                p78,mw,p45,mw,dl(13))
      end if
      if (ikin0 /= 14 .and. awa(14) > 0.d0) then
       call psneetbff(0,2,ecm,zero,zero,zero,zero,
     &                p1,m1,p2,m2,p6,m6,p3,m3,
     &                p78,mw,p45,mw,dl(14))
      end if
      if (ikin0 /= 15 .and. awa(15) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mt,gamt,mt,gamt,
     &                p1,m1,p2,m2,p3,m3,
     &                p45,mw,p6,m6,p78,mw,dl(15))
      end if
      if (ikin0 /= 16 .and. awa(16) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,
     &                p1,m1,p2,m2,p45,mw,p78,mw,
     &                p3,m3,p6,m6,dl(16))
      end if
      if (ikin0 /= 17 .and. awa(17) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,
     &                p1,m1,p2,m2,p3,m3,p6,m6,
     &                p45,mw,p78,mw,dl(17))
      end if
      if (ikin0 /= 18 .and. awa(18) > 0.d0) then
       call psneeffff(0,0,2,2,ecm,zero,zero,zero,zero,
     &                p1,m1,p2,m2,p45,mw,p78,mw,
     &                p3,m3,p6,m6,dl(18))
      end if
      if (ikin0 /= 19 .and. awa(19) > 0.d0) then
       call psneeffff(0,0,2,2,ecm,zero,zero,zero,zero,
     &                p1,m1,p2,m2,p3,m3,p6,m6,
     &                p45,mw,p78,mw,dl(19))
      end if
      if (ikin0 /= 20 .and. awa(20) > 0.d0) then
       call psneeffff(0,0,1,2,ecm,mz,gamz,zero,zero,
     &                p1,m1,p2,m2,p45,mw,p78,mw,
     &                p3,m3,p6,m6,dl(20))
      end if
      if (ikin0 /= 21 .and. awa(21) > 0.d0) then
       call psneeffff(0,0,2,1,ecm,zero,zero,mz,gamz,
     &                p1,m1,p2,m2,p3,m3,p6,m6,
     &                p45,mw,p78,mw,dl(21))
      end if




      do i=1,nkina
       if (dl(i) /= 0.d0 .and. awa(i) > zero) then
        dlinv=dlinv+awa(i)/abs(dl(i))
       end if
      end do

      if (dlinv == 0.d0) then
       cross=0.d0
       return
      else

      dlips=1.d0/dlinv

      if (imad == 2) then
       mat2=1.d0
      else
       call eebwbw(3,3,p1,p2,p3,p45,p6,p78,
     &                         ps1,ps2,ps3,ps45,ps6,ps78,mat2)
      end if ! imad=2

      cross=convc/flux*mat2*dlips*brw45*brw78

c      if (imad == 1) then
c          mat2m=stbtn(p1,p2,p3,p45,p6,p78)
c          crossm=convc/flux*mat2m*dlips
c          write(*,*) mat2,mat2m,mat2-mat2m
c      end if ! imad

       icall=icall+1

c Find the maximum of cross

      if (cross > crmax) then
       if (iscan == 0) then
        write(*,3010) crmax,cross
       end if
       crmax=cross
      end if

      if (iscan == 0) then

      call random_number(rand)

      if (cross > rand*crmax) then
       ieff=ieff+1
       if (imc == 1) then
        write(*,1000) ieff
        write(*,1030) p3
        write(*,1045) p45
        write(*,1060) p6
        write(*,1075) p78
       end if
      end if

      end if

 1045 format('p+:',4e16.8)
 1075 format('p-:',4e16.8)


       end if  !  dlinv

       else  !  dl(ikin) 

        cross=0.d0
        return

       end if  !  dl(ikin) 

      else  ! idrive

       write(*,*)'idrive=',idrive,' is not allowed'
       stop

      end if  ! idrive

c Distriubutions:

      if (idis == 1 .and. iscan == 0) then

       if (idrive == 1) then

        xd(1)=srr(p3+p4+p5,p3+p4+p5)
        xd(2)=srr(p6+p7+p8,p6+p7+p8)
        xd(3)=sqrt(abs(xd(1)))
        xd(4)=ps5(1)
        xd(5)=ps7(1)
        pv345=p3(1:)+p4(1:)+p5(1:)
        xd(6)=pv345(3)/sqrt(pv345(1)**2+pv345(2)**2+pv345(3)**2)

       else if (idrive == 2) then

        xd(1)=srr(p3+p45,p3+p45)
        xd(2)=srr(p6+p78,p6+p78)
        xd(3)=sqrt(abs(xd(1)))
        xd(4)=ps45(1)
        xd(5)=ps78(1)
        pv345=p3(1:)+p45(1:)
        xd(6)=pv345(3)/sqrt(pv345(1)**2+pv345(2)**2+pv345(3)**2)

       end if ! idrive


        do j=1,ndist
         if (xd(j) >= xmin(j) .and. xd(j) <= xmax(j)) then
          do i=1,nbs(j)
           if (xd(j) <= xdi(i,j)) then
            ibin(j)=i
            ncs(i,j)=ncs(i,j)+1
            exit
           end if
          end do
         else
          ibin(j)=0
         end if
        end do

      end if ! idist


      end




