      subroutine eee(p1,e1,p2,e2,p3,e3,mat,i1,i2,i3)
c----------------------------------------------------------------------c
c Returns a contraction of the triple gauge boson coupling with 3 
c complex four vectors
c
c Input: p1 - four momentum of the outgoing W-,
c        e1 - four vector contracted with the outgoing W-,
c        i1 - No of polarizations of e1,
c        p2 - four momentum of the incoming W-,
c        e2 - four vector contracted with the incoming W-,
c        i2 - No of polarizations of e2,
c        p3 - four momentum of the neutral gauge boson,
c        e3 - four vector contracted with the neutral gauge boson,
c        i3 - No of polarizations of e3.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 30 March, 1998; modiffied 1 April, 1998
c----------------------------------------------------------------------c

      implicit none

      integer i1,i2,i3,i,j,k
      complex(8) src,scc
      real(8), dimension(0:3) :: p1,p2,p3,p23,p13,p12
      complex(8), dimension(i1,i2,i3) :: mat
      complex(8), dimension(0:3,i1) :: e1
      complex(8), dimension(0:3,i2) :: e2
      complex(8), dimension(0:3,i3) :: e3
      complex(8), dimension(i1) :: o1
      complex(8), dimension(i2) :: o2
      complex(8), dimension(i3) :: o3
      complex(8), dimension(i1,i2) :: o12
      complex(8), dimension(i1,i3) :: o13
      complex(8), dimension(i2,i3) :: o23

      p23=p2-p3
      p13=p1+p3
      p12=p1+p2

      do i=1,i1
        o1(i)=src(p23,e1(:,i))
        do j=1,i2
          o12(i,j)=scc(e1(:,i),e2(:,j))
        end do
        do k=1,i3
          o13(i,k)=scc(e1(:,i),e3(:,k))
        end do
      end do

      do j=1,i2
        o2(j)=src(p13,e2(:,j))
        do k=1,i3
          o23(j,k)=scc(e2(:,j),e3(:,k))
        end do
      end do

      do k=1,i3
        o3(k)=src(p12,e3(:,k))
      end do

      do i=1,i1
        do j=1,i2
          do k=1,i3
            mat(i,j,k)=-o3(k)*o12(i,j)+o23(j,k)*o1(i)+o2(j)*o13(i,k)
          end do
        end do
      end do

      end 






