      subroutine eeh(gh,p,mh2,e1,n1,e2,n2,scal)
c----------------------------------------------------------------------c
c Returns a contraction of the Higgs - gauge boson coupling with 2 
c complex four vectors
c
c Input: gh  - Higgs - gauge boson coupling,
c        p - four momentum of the Higgs boson,
c        mh2- complex mass squared of the uncontracted Higgs boson,
c        e1,e2 - polarization four vectors,
c        n1,n2 - No of polarizations of e1,e2.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 3 July, 2001; modified 
c----------------------------------------------------------------------c

      implicit none

      integer :: n1,n2
      complex(8), dimension(0:3,n1) :: e1
      complex(8), dimension(0:3,n2) :: e2
      real(8), dimension(0:3) :: p
      complex(8) :: gh,mh2
      complex(8), dimension(n1,n2) :: scal

      integer :: i1,i2
      real(8) :: srr
      complex(8) :: ghden,scc

      ghden=gh/(cmplx(srr(p,p),0.d0,8)-mh2)

      do i1=1,n1
       do i2=1,n2
         scal(i1,i2)=ghden*scc(e1(:,i1),e2(:,i2))
       end do
      end do

      end 






