      subroutine parfix
c----------------------------------------------------------------------c
c Returns paprameters of the specific e+ e- -> 6f process
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 15 June, 2001; modified 
c----------------------------------------------------------------------c

      use inprms
      use mathprms 
      use parproc
      use drivec

      implicit none

      integer i
      real(8) :: a,rwt,gwt,gamtsm,gamt3,gamhsm,bth,gamw45,gamw78,
     &           gamtsm0,gamt345,gamt678,gamwsm0,gamw0
      real(8), dimension(3,2) :: ml,mq,gaml,gamq
      complex(8) :: cmw,cmh

c Coupling constants:

      e0=sqrt(4.d0*pi/ralp0)
      ew=sqrt(4.d0*pi/ralpw)
      gqq=sqrt(4.d0*pi*alphas)

c The SM top width:

c---- total:

      gamtsm0=gmu*mt**3/(8.d0*pi*sqrt(2.d0))
     &       *(1.d0-(mw/mt)**2)**2*(1.d0+2.d0*(mw/mt)**2)

      gamtsm=gmu*mt**3/(8.d0*pi*sqrt(2.d0))
     &      *(1.d0-(mw/mt)**2)**2*(1.d0+2.d0*(mw/mt)**2)
     &      *(1.d0-2.d0*alphas/(3.d0*pi)*(2.d0*pi**2/3.d0-5.d0/2.d0))

c---- partial (t -> b l+ vl)

      rwt=mw/mt
      gwt=gamw/mt

      gamt3=gmu**2*mt**3*mw**2/(96.d0*pi**3)
     &     *((1.d0-3.d0*rwt**4+2.d0*rwt**6+3.d0*rwt**2*gwt**2
     &       -6.d0*rwt**4*gwt**2)*mw/gamw*(pi
     &       -atan(mt**2*gamw/(mw*(mt**2-mw**2-gamw**2))))
     &      +(3.d0*rwt**4-3.d0*rwt**6+rwt**4*gwt**2)
     &  *log(mw**2*(mw**2+gamw**2)/((mt**2-mw**2)**2+mw**2*gamw**2)))


      if (gamh == 0.d0) then

c The SM Higgs width:

      gamhsm=sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &      *(mtau**2*(sqrt(1.d0-4.d0*(mtau/mh)**2))**3
     & +3.d0*(mc**2*(sqrt(1.d0-4.d0*(mc/mh)**2))**3
     &       +mb**2*(sqrt(1.d0-4.d0*(mb/mh)**2))**3))

      if (mh > 2.d0*mt) then
       bth=1.d0-4.d0*(mt/mh)**2
       gamhsm=gamhsm+sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &      *(3.d0*(mt**2*(sqrt(bth))**3))
      end if

      if (imad == 1) then
       gamhig=gamh
      else
       gamhig=gamhsm
      end if

      else

      gamhig=gamh

      end if

c Particle masses:

      ml(:,1)=(/zero,zero,zero/)
      ml(:,2)=(/me,mmu,mtau/)
      mq(:,1)=(/mu,mc,mt/)
      mq(:,2)=(/md,ms,mb/)

      gaml(:,1)=(/zero,zero,zero/)
      gaml(:,2)=(/game,gammu,gamtau/)
      gamq(:,1)=(/gamu,gamc,gamt/)
      gamq(:,2)=(/gamd,gams,gamb/)

      m1=me
      m2=me
      m3=mb
      m6=mb

      colfac1=1.d0
      colfac2=ncol/4.d0
      colfac3=(ncol**2-1.d0)/4.d0/ncol**2

      if (iwp == 1) then
       m4=ml(ifp,1)
       gam4=gaml(ifp,1)
       m5=ml(ifp,2)
       gam5=gaml(ifp,2)
       dm4=cmplx(ml(ifp,2),-gaml(ifp,2)/2.d0,8)
       dm5=cmplx(ml(ifp,1),-gaml(ifp,1)/2.d0,8)
       if (ifp == 2) then
        chwp='vm mu+'
       else if (ifp == 3) then
        chwp='vt ta+'
       else
        write(*,*)'ifp=',ifp,' is not yet implemented for leptons'
        stop
       end if ! ifp
       call wwidth(m4,m5,mw,one,one,ew,sw2,gamw45)
       gamt345=gamt3
      else if (iwp == 2) then
       m4=mq(ifp,1)
       gam4=gamq(ifp,1)
       m5=mq(ifp,2)
       gam5=gamq(ifp,2)
       dm4=cmplx(mq(ifp,2),-gamq(ifp,2)/2.d0,8)
       dm5=cmplx(mq(ifp,1),-gamq(ifp,1)/2.d0,8)
       if (ifp == 1) then
        chwp='u d~'
       else if (ifp == 2) then
        chwp='c s~'
       else
        write(*,*)'ifp=',ifp,' is not implemented for quarks'
        stop
       end if ! ifp
       call wwidth(m4,m5,mw,ncol,one,ew,sw2,gamw45)
       gamt345=ncol*gamt3
       colfac1=ncol*colfac1
       colfac3=ncol*colfac3
      else
       write(*,*)'iwp =',iwp,'is not allowed'
      end if

      if (iwm == 1) then
       m7=ml(ifm,2)
       gam7=gaml(ifm,2)
       m8=ml(ifm,1)
       gam8=gaml(ifm,1)
       dm7=cmplx(ml(ifm,1),-gaml(ifm,1)/2.d0,8)
       dm8=cmplx(ml(ifm,2),-gaml(ifm,2)/2.d0,8)
       if (ifm == 2) then
        chwm='mu- vm~'
       else if (ifm == 3) then
        chwm='ta- vt~'
       else
        write(*,*)'ifm=',ifm,' is not yet implemented for leptons'
        stop
       end if ! ifm
       gamt678=gamt3
       call wwidth(m7,m8,mw,one,one,ew,sw2,gamw78)
      else if (iwm == 2) then
       m7=mq(ifm,2)
       gam7=gamq(ifm,2)
       m8=mq(ifm,1)
       gam8=gamq(ifm,1)
       dm7=cmplx(mq(ifm,1),-gamq(ifm,1)/2.d0,8)
       dm8=cmplx(mq(ifm,2),-gamq(ifm,2)/2.d0,8)
       if (ifm == 1) then
        chwm='d u~'
       else if (ifm == 2) then
        chwm='c s~'
       else
        write(*,*)'ifm=',ifm,' is not implemented for quarks'
        stop
       end if ! ifm
       call wwidth(m7,m8,mw,ncol,one,ew,sw2,gamw78)
       gamt678=ncol*gamt3
       colfac1=ncol*colfac1
       colfac3=ncol*colfac3
      else
       write(*,*)'iwm =',iwm,'is not allowed'
      end if

      gamwsm0=zero
      call wwidth(zero,me,mw,one,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(zero,mmu,mw,one,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(zero,mtau,mw,one,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(mu,md,mw,ncol,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(mc,ms,mw,ncol,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0

      brw45=gamw45/gamw
      brw78=gamw78/gamw
      brt345=gamt345/gamt
      brt678=gamt678/gamt


c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(10)+...=1

      aw0=zero

      if (itt == 1) then
       a=0.5d0
       aw0(1)=a
       aw0(30)=a
      else if (iww == 1) then
       a=1.d0/33.d0
       aw0(1:33)=a
      else
       if (iwp == 2 .and. iwm == 1) then
        aw0(1:59)=1.d0/58.d0
        aw0(52)=0.d0
       else if (iwp == 1 .and. iwm == 2) then
        aw0(1:59)=1.d0/58.d0
        aw0(59)=0.d0
       else if (iwp == 1 .and. iwm == 1) then
        aw0(1:59)=1.d0/57.d0
        aw0(52)=0.d0
        aw0(59)=0.d0
       else 
        aw0(1:59)=1.d0/59.d0
       end if

      end if


c Arbitrary weights for the approximated cross section: awa0(1)+...+awa0(21)=1

      awa0=zero

      a=1.d0/21.d0
      awa0(1:21)=a


c Complex masses squared:

      mw2=cmplx(mw**2,-mw*gamw,8)
      ma2=cmplx(zero,zero,8)
      mz2=cmplx(mz**2,-mz*gamz,8)
      mh2=cmplx(mh**2,-mh*gamhig,8)

c Complex fermion masses:

      cm1=cmplx(m1,-gam1/2.d0,8)
      cm2=cmplx(m2,-gam2/2.d0,8)
      cm3=cmplx(m3,-gam3/2.d0,8)
      cm4=cmplx(m4,-gam4/2.d0,8)
      cm5=cmplx(m5,-gam5/2.d0,8)
      cm6=cmplx(m6,-gam6/2.d0,8)
      cm7=cmplx(m7,-gam7/2.d0,8)
      cm8=cmplx(m8,-gam8/2.d0,8)

      dm1=ocom
      dm2=ocom
      dm3=cmplx(mt,-gamt/2.d0,8)
      dm6=cmplx(mt,-gamt/2.d0,8)

      if (ischeme == 1) then
        csw2=(mz2-mw2)/mz2
        cmw=sqrt(mw2)
        cmh=sqrt(mh2)
        if (ialpw == 1) then
         cralpw=4.44288293815837d0/(2.d0*csw2*gmu*mw2)
        else if (ialpw == 0) then
         cralpw=4.44288293815837d0/(2.d0*sw2*gmu*mw**2)
        else
         write(*,1010) ialpw
 1010    format('# ialpw =',i2,' is not allowed in this context')
        end if
      else
        csw2=cmplx(sw2,0.d0,8)
        cmw=cmplx(mw,0.d0,8)
        cmh=cmplx(mh,0.d0,8)
        cralpw=4.44288293815837d0/(2.d0*csw2*gmu*mw**2)
      end if


      cew=sqrt(cmplx(4.d0*pi,0.d0,8)/cralpw)
      calpw=(cew/ew)**12


c Couplings:

      call couplsmb(ew,csw2,cmw,cmh)

      ga1=gll
      gz1=zll
      ga2=gll
      gz2=zll
      ga3=gdd
      gz3=zdd
      ga6=gdd
      gz6=zdd
      gg3=gqq**2/gdd

      if (iwp == 1) then
       ga4=gnn
       gz4=znn
       ga5=gll
       gz5=zll
       gg4=ocom
       gg5=ocom
      else if (iwp == 2) then
       ga4=guu
       gz4=zuu
       ga5=gdd
       gz5=zdd
       gg4=gqq**2/guu
       gg5=gqq**2/gdd
      else
       write(*,*)'iwp =',iwp,'is not allowed'
      end if

      if (iwm == 1) then
       ga7=gll
       gz7=zll
       ga8=gnn
       gz8=znn
       gg7=ocom
       gg8=ocom
      else if (iwm == 2) then
       ga7=gdd
       gz7=zdd
       ga8=guu
       gz8=zuu
       gg7=gqq**2/gdd
       gg8=gqq**2/guu
      else
       write(*,*)'iwm =',iwm,'is not allowed'
      end if

      end subroutine parfix
