      subroutine spheric(p,ps)
c----------------------------------------------------------------------c
c Returns spherical components ps of a four vector p:
c
c                 ps=(/pp,ct,st,cf,sf/)
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 3 July, 2001; modiffied on 
c----------------------------------------------------------------------c

      implicit none

      real(8) :: p(0:3),ps(0:4),pst

      ps(0)=sqrt(p(1)**2+p(2)**2+p(3)**2)
      ps(1)=p(3)/ps(0)
      if (abs(ps(1)) < 1.d0) then
        ps(2)=sqrt(1.d0-ps(1)**2)
        pst=ps(0)*ps(2)
        ps(3)=p(1)/pst
        ps(4)=p(2)/pst
       else if (ps(1) >= 1.d0) then
        ps(1:)=(/1.d0,0.d0,1.d0,0.d0/)
       else if (ps(1) <= -1.d0) then
        ps(1:)=(/-1.d0,0.d0,-1.d0,0.d0/)
       end if

      end
